version: '3'

services:
  tenant-server:
    image: tenant-server:latest
    ports:
      - "8000:8000"
    depends_on:
      - mongo
    links:
      - mongo
    environment:
      - NODE_ENV=production
      - DB_HOST=mongo
      - DB_NAME=${DB_NAME}
      - DB_USER=${DB_USER}
      - DB_PASSWORD=${DB_PASSWORD}
      - EVENTS_PROTO=mqtt
      - EVENTS_USER=${EVENTS_USER}
      - EVENTS_PASSWORD=${EVENTS_PASSWORD}
      - EVENTS_HOST=events
      - EVENTS_PORT=1883

  mongo:
    image: bitnami/mongodb:latest
    environment:
      - MONGODB_ROOT_PASSWORD=${DB_PASSWORD}
      - MONGODB_USERNAME=${DB_USER}
      - MONGODB_PASSWORD=${DB_PASSWORD}
      - MONGODB_DATABASE=${DB_NAME}
    volumes:
      - mongo-vol:/bitnami

  events:
    image: emqx/emqx:latest
    environment:
      - EMQX_ALLOW_ANONYMOUS=false
      - EMQX_LOADED_PLUGINS=emqx_management,emqx_auth_mnesia,emqx_recon,emqx_retainer,emqx_dashboard

  events-config:
    image: byrnedo/alpine-curl:latest
    environment:
      - EVENTS_USER=${EVENTS_USER?Variable EVENTS_USER not set}
      - EVENTS_PASSWORD=${EVENTS_PASSWORD?Variable EVENTS_PASSWORD not set}
    depends_on:
      - events
    entrypoint: ["/bin/sh", "-c"]
    command:
      - sleep 5;
        curl -i --basic -u admin:public -X POST http://events:8081/api/v4/mqtt_user -d '{"login":"$EVENTS_USER","password":"$EVENTS_PASSWORD","is_superuser":false}'

volumes:
  mongo-vol:
  events-config-vol:
